/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package calc.implementation;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.registry.Registry;
import java.rmi.RMISecurityManager;
import java.rmi.registry.LocateRegistry;

import calc.CalcRemoteInterface;

//import java.util.logging.Level;
//import java.util.logging.Logger;

/**
 *
 * @author alessiobechini
 */
public class CalcServer {
    
    private static final int REGISTRY_PORT=1099;
    private static Registry myRegistry; //actually not used, just returned value at creation

    public CalcServer() {
        
        try {
            CalcRemoteInterface c = new CalcRemoteObj();
            Naming.rebind("rmi://localhost:"+Integer.toString(REGISTRY_PORT)+"/Calculator", c);
        } catch (Exception e) { 
            System.out.println("Trouble: " + e);
            e.printStackTrace();
        }
    }

    public static void startRegistry(int port) throws RemoteException{

        myRegistry=LocateRegistry.createRegistry(REGISTRY_PORT);
        System.out.println("Registry created - port "+Integer.toString(REGISTRY_PORT));
        
        //attenzione ad usare LocateRegistry.createRegistry(..):
        //il metodo crea un riferimento locale, senza fare la connessione
        //e dunque i problemi, se ci sono, si riveleranno solo successivamente
    }

    /**
     * @param args the command line arguments
     * @throws Exception  
     */
    public static void main(String[] args) throws Exception {
        
        if (System.getSecurityManager() == null) {
            System.setSecurityManager(new RMISecurityManager());
        }
        
        startRegistry(REGISTRY_PORT);
                       
        
        new CalcServer();
    }
}
